include:
  remote: "https://gitlab.com/arbetsformedlingen/devops/gitlab-cicd/jobtech-ci/-/raw/v1.1.3/jobtech-ci.yml"

variables:
  TEST_DISABLED: true # Disable buildpack that doesn't work with Poetry.
  PYTHON_IMG: "python:3.12.1-bookworm"
  POETRY_VERSION: "1.8.0"
  TZ: Europe/Stockholm

# Install pinned version of Poetry
# https://python-poetry.org/docs/#ci-recommendations
.poetry_setup: &poetry_setup
  variables:
    POETRY_HOME: /opt/poetry
  before_script:
    - python --version
    - python -m venv $POETRY_HOME
    - $POETRY_HOME/bin/pip install --upgrade pip
    - $POETRY_HOME/bin/pip install poetry==$POETRY_VERSION
    - $POETRY_HOME/bin/poetry --version
    - export PATH=$PATH:$POETRY_HOME/bin
    - poetry install --with=dev

unit_tests:
  <<: *poetry_setup
  image: $PYTHON_IMG
  stage: test
  script:
    - poetry run pytest -rsv --cov joblinks --cov-report term --cov-report xml:coverage.xml --junit-xml report.xml tests/unit_tests
  coverage: '/(?i)total.*? (100(?:\.0+)?\%|[1-9]?\d(?:\.\d+)?\%)$/'
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage.xml
      junit: report.xml
